val env = let
	      val env = Symbol.new ()
	  in
	      initializeEnv env; env
	  end

open Expression;

(*   val seq = fn com1 => fn com2 => com2 in
 *   val id = fn x => x in ((seq (id 2)) (id true))
 *)

Elab.elab (env, ValExp ("seq", FnExp ("com1", FnExp ("com2", VarExp "com2")),
			ValExp ("id", FnExp ("x", VarExp "x"),
				AppExp (AppExp (VarExp "seq",
						AppExp (VarExp "id", VarExp "one")),
					AppExp (VarExp "id", VarExp "true")))));

(*   (o fst) ((o snd) ((o pair) before))   *)

Elab.elab (env, AppExp (AppExp (VarExp "o", VarExp "fst"),
			AppExp (AppExp (VarExp "o", VarExp "snd"),
				AppExp (AppExp (VarExp "o", VarExp "pair"),
					VarExp "before"))));
