type ty

type tycon = string

exception Unification of string   (* error message *)

val var: unit -> ty
val cons: tycon * ty list -> ty
val unify: ty * ty -> unit        (* Unification *)

val instantiate: ty -> ty
val beginScheme: unit -> unit
val endScheme: ty -> unit

val toString: ty -> string
